from __future__ import annotations
from typing import List
from data_point import DataPoint
from pr74_1 import KMeans


class Governor(DataPoint):
    def __init__(self, longitude: float, age: float, state: str) -> None:
        super().__init__([longitude, age])
        self.longitude = longitude
        self.age = age
        self.state = state

    def __repr__(self) -> str:
        return f"{self.state}: (долгота: {self.longitude}, возраст: {self.age})"

if __name__ == "__main__":
    governors: List[Governor] = [Governor(-86.79113, 72, "Алабама"), Governor(-152.404419, 66, "Аляска"),
                                 Governor(-111.431221, 53, "Аризона"), Governor(-92.373123, 66, "Арканзас"),
                                 Governor(-119.681564, 79, "Калифорния"), Governor(-105.311104, 65, "Колорадо"),
                                 Governor(-72.755371, 61, "Коннектикут"), Governor(-75.507141, 61, "Делавер"),
                                 Governor(-81.686783, 64, "Флорида"), Governor(-83.643074, 74, "Джорджия"),
                                 Governor(-157.498337, 60, "Гавайи"), Governor(-114.478828, 75, "Айдахо"),
                                 Governor(-88.986137, 60, "Иллинойс"), Governor(-86.258278, 49, "Индиана"),
                                 Governor(-93.210526, 57, "Юта"), Governor(-96.726486, 60, "Канзас"),
                                 Governor(-84.670067, 50, "Кентукки"), Governor(-91.867805, 50, "Луизиана"),
                                 Governor(-69.381927, 68, "Мэн"), Governor(-76.802101, 61, "Мэриленд"),
                                 Governor(-71.530106, 60, "Массачусетс"), Governor(-84.536095, 58, "Мичиган"),
                                 Governor(-93.900192, 70, "Миннесота"), Governor(-89.678696, 62, "Миссисипи"),
                                 Governor(-92.288368, 43, "Миссури"), Governor(-110.454353, 51, "Монтана"),
                                 Governor(-98.268082, 52, "Небраска"), Governor(-117.055374, 53, "Невада"),
                                 Governor(-71.563896, 42, "Нью-Гэмпшир"), Governor(-74.521011, 54, "Нью-Джерси"),
                                 Governor(-106.248482, 57, "Нью-Мексико"), Governor(-74.948051, 59, "Нью-Йорк"),
                                 Governor(-79.806419, 60, "Северная Каролина"), Governor(-99.784012, 60, "Северная Дакота"),
                                 Governor(-82.764915, 65, "Огайо"), Governor(-96.928917, 62, "Оклахома"),
                                 Governor(-122.070938, 56, "Орегон"), Governor(-77.209755, 68, "Пенсильвания"),
                                 Governor(-71.51178, 46, "Род-Айленд"), Governor(-80.945007, 70, "Южная Каролина"),
                                 Governor(-99.438828, 64, "Южная Дакота"), Governor(-86.692345, 58, "Теннесси"),
                                 Governor(-97.563461, 59, "Техас"), Governor(-111.862434, 70, "Юта"),
                                 Governor(-72.710686, 58, "Вермонт"), Governor(-78.169968, 60, "Виргиния"),
                                 Governor(-121.490494, 66, "Вашингтон"), Governor(-80.954453, 66, "Западная Виргиния"),
                                 Governor(-89.616508, 49, "Висконсин"), Governor(-107.30249, 55, "Вайоминг")]
    kmeans: KMeans[Governor] = KMeans(2, governors)
    gov_clusters: List[KMeans.Cluster] = kmeans.run()
    for index, cluster in enumerate(gov_clusters):
        print(f"Кластер {index}: {cluster.points}\n")
